#!/bin/bash

# fail if any command fails
set -e

if [[ -z "${API_KEY}" ]]; then
  echo "API_KEY not defined, should be api key to CJVT's gitea"
  exit 1
fi

OUT_FILE=conversions.csv
TEMP_FILE=$(mktemp)

rm -r $OUT_FILE

curl -s "https://gitea.cjvt.si/api/v1/repos/generic/data_admin/contents/resources/structure_conversions.csv?token=$API_KEY" -o $TEMP_FILE
echo "wc: $(wc $TEMP_FILE)"
cat $TEMP_FILE | python3 -c "import sys, json; print(json.load(sys.stdin)['content'])" | base64 -d > $OUT_FILE

rm -rf $TEMP_FILE
